#property copyright "Copyright c 2006-2008, TrendStuffer.com"
#property link      "http://www.trendstuffer.com/"

#include <stdlib.mqh>

extern string t0 = "**TrendStuffer.com v4.0 EA TRIAL**";
extern string t1 = "**Best performance on Alpari UK charts**";
extern string mfx = "Get 1.5pip spread on EUR/USD, visit";
extern string mfx2 = "www.MandloysFX.com";
extern string t2 = "Official TrendStuffer Forum:";
extern string t3 = "www.Investeroid.com";
extern string t27 = "-=[Personal Serial Number]=-";
extern string Serial = "YiSDr4eXcY";
extern string t01 = "-=[General EA settings]=-";
extern string m1 = "Micro lots mean 0.01 lots!";
extern bool UseMicroLots = FALSE;
extern int MaxSlippage = 5;
extern int OrderTriesNumber = 10;
extern int StartHour = 0;
extern int EndHour = 24;
extern int ExpirationHour = 24;
extern int DetailedLog = 1;
extern string t6 = "-=[How to calculate lot size?]=-";
extern string t7 = "1 - Manual input";
extern string t8 = "2 - Automatic calculations";
extern int LotCalc = 2;
extern string t9 = "-=[If using automatic calculations]=-";
extern string t10 = "Maximum risk per trade in percentage";
extern int MaximumRisk = 5;
extern string t23 = "-=[If using manual lot size inputs]=-";
extern double LotSize = 1.0;
extern string t28 = "-=[Position\'s settings?]=-";
extern int TSSMagic = 32159876;
extern string PositionComment = "TrendStuffer SP";
extern double TakeProfit = 800.0;
extern double StopLoss = 400.0;
extern bool UseTrailingStop = FALSE;
extern int TrailingStart = 70;
extern int TrailingStop = 110;
extern bool UseBreakEven = FALSE;
extern int BreakEvenDistance = 20;
extern int BreakEvenSLTo = 5;
extern string t29 = "-=[Manual currency pair selection]=-";
extern string t30 = "Only if automatic detection fails!";
extern string t37 = "0 - Off, 1 - ON";
extern int ManualSelection = 0;
extern int Currency = 1;
extern string t31 = "1 EURUSD, 2 GBPUSD, 3 USDCHF, 4 USDJPY";
extern string t33 = "5 AUDUSD, 6 GBPCHF, 7 GBPJPY, 8 EURJPY";
extern string t34 = "9 CADJPY, 10 EURGBP, 11 NZDUSD, 12 EURCHF";
extern string t35 = "13 AUDJPY, 14 CADCHF, 15 USDDKK, 16 USDNOK";
extern string t36 = "17 USDSEK";
extern string t32 = "-=[End of setup]=-";
bool gi_388;
bool gi_392;
bool gi_396;
bool gi_400;
int gi_404;
int g_count_408;
datetime g_time_412;
double g_icustom_416;
double g_icustom_424;
int gi_432 = 0;
double gd_436;
string gs_444 = "EA initiated, waiting for first signal";

int init() {
   return (0);
}

void start() {
   if (Bars < 100 || IsTradeAllowed() == FALSE) return;
   int l_hour_0 = TimeHour(TimeCurrent());
   if (l_hour_0 == ExpirationHour) {
      Print("It\'s Expiration Hour, trying to close all trades.");
      ClearAllTrades();
   }
   if (StartHour <= l_hour_0 && EndHour >= l_hour_0) {
      CheckForSignals();
      if (CalculateCurrentOrders() != 0) CheckForClose();
      else CheckForOpen();
      if (CalculateCurrentOrders() != 0) {
         if (UseTrailingStop == TRUE) TrailStop();
         if (UseBreakEven == TRUE) BreakEven();
      }
   }
   Commenting();
}

double LotsRisk(int ai_0) {
   if (UseMicroLots == FALSE) {
      if (LotCalc == 1) {
         gd_436 = NormalizeDouble(LotSize, 1);
         if (gd_436 < 0.1) gd_436 = 0.1;
         if (DetailedLog == 1) Print("TrendStuffer v4: Not using lot calculations, lot size: " + gd_436);
         gs_444 = "TrendStuffer v4: Not using lot calculations, lot size: " + gd_436;
      }
      if (LotCalc == 2) {
         gd_436 = NormalizeDouble(AccountFreeMargin() * MaximumRisk / 1000.0 / ai_0, 1);
         if (gd_436 < 0.1) gd_436 = 0.1;
         if (DetailedLog == 1) Print("TrendStuffer v4: Not using microlots, calculated lot size: " + gd_436);
         gs_444 = "TrendStuffer v4: Not using microlots, calculated lot size: " + gd_436;
      }
   }
   if (UseMicroLots == TRUE) {
      if (LotCalc == 1) {
         gd_436 = NormalizeDouble(LotSize, 2);
         if (gd_436 < 0.01) gd_436 = 0.01;
         if (DetailedLog == 1) Print("TrendStuffer v4: Not using lot calculations, lot size: " + gd_436);
         gs_444 = "TrendStuffer v4: Not using lot calculations, lot size: " + gd_436;
      }
      if (LotCalc == 2) {
         gd_436 = NormalizeDouble(AccountFreeMargin() * MaximumRisk / 1000.0 / ai_0, 2);
         if (gd_436 < 0.01) gd_436 = 0.01;
         if (DetailedLog == 1) Print("TrendStuffer v4: Using microlots, calculated lot size: " + gd_436);
         gs_444 = "TrendStuffer v4: Using microlots, calculated lot size: " + gd_436;
      }
   }
   return (gd_436);
}

int CalculateCurrentOrders() {
   int l_count_0 = 0;
   int l_count_4 = 0;
   for (int l_pos_8 = 0; l_pos_8 < OrdersTotal(); l_pos_8++) {
      if (OrderSelect(l_pos_8, SELECT_BY_POS, MODE_TRADES) == FALSE) break;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == TSSMagic) {
         if (OrderType() == OP_BUY) {
            l_count_0++;
            Print("Found TSS v4 BUY position, starting to manage.");
            gs_444 = "Found TSS v4 BUY position, starting to manage.";
         }
         if (OrderType() == OP_SELL) {
            l_count_4++;
            Print("Found TSS v4 SELL position, starting to manage.");
            gs_444 = "Found TSS v4 SELL position, starting to manage.";
         }
      }
   }
   if (l_count_0 > 0) return (l_count_0);
   return (-l_count_4);
}

void CheckForSignals() {
   if (g_time_412 != Time[0]) {
      g_time_412 = Time[0];
      g_icustom_424 = iCustom(NULL, 0, "TrendStuffer-v4-base-trial", ManualSelection, Currency, Serial, 0, 2);
      g_icustom_416 = iCustom(NULL, 0, "TrendStuffer-v4-base-trial", ManualSelection, Currency, Serial, 0, 0);
   }
   gi_392 = FALSE;
   gi_388 = FALSE;
   if (Close[1] > g_icustom_424 && Close[2] <= g_icustom_424 && Open[0] >= g_icustom_416 && Open[2] <= g_icustom_424) gi_388 = TRUE;
   if (Close[1] < g_icustom_424 && Close[2] >= g_icustom_424 && Open[0] <= g_icustom_416 && Open[2] >= g_icustom_424) gi_392 = TRUE;
   gi_400 = gi_388;
   gi_396 = gi_392;
   if (gi_400 || gi_396) return;
   if (CalculateCurrentOrders() != 0) {
      gi_400 = FALSE;
      gi_396 = FALSE;
   }
}

void CheckForOpen() {
   int l_ticket_0;
   if (gi_392 && gi_404 != -1) {
      if (DetailedLog == 1) Print("TrendStuffer v4: Found SELL signal, initiating OrderSend");
      gs_444 = "TrendStuffer v4: Found SELL signal, initiating OrderSend";
      l_ticket_0 = 0;
      g_count_408 = 0;
      while (l_ticket_0 <= 0 && g_count_408 < OrderTriesNumber) {
         while (!IsTradeAllowed()) Sleep(5000);
         l_ticket_0 = OrderSend(Symbol(), OP_SELL, LotsRisk(StopLoss), Bid, MaxSlippage, Bid + StopLoss * Point, Bid - TakeProfit * Point, PositionComment, TSSMagic, 0, Red);
         if (l_ticket_0 < 0) {
            Print("TrendStuffer v4: Error opening SELL order! ", ErrorDescription(GetLastError()));
            gs_444 = "TrendStuffer v4: Error opening SELL order! " + ErrorDescription(GetLastError());
            g_count_408++;
         }
      }
      gi_404 = -1;
      return;
   }
   if (gi_388 && gi_404 != 1) {
      if (DetailedLog == 1) Print("TrendStuffer v4: Found BUY signal, initiating OrderSend");
      gs_444 = "TrendStuffer v4: Found BUY signal, initiating OrderSend";
      l_ticket_0 = 0;
      g_count_408 = 0;
      while (l_ticket_0 <= 0 && g_count_408 < OrderTriesNumber) {
         while (!IsTradeAllowed()) Sleep(5000);
         l_ticket_0 = OrderSend(Symbol(), OP_BUY, LotsRisk(StopLoss), Ask, MaxSlippage, Ask - StopLoss * Point, Ask + TakeProfit * Point, PositionComment, TSSMagic, 0, Blue);
         if (l_ticket_0 < 0) {
            Print("TrendStuffer v4: Error opening BUY order! ", ErrorDescription(GetLastError()));
            gs_444 = "TrendStuffer v4: Error opening BUY order! " + ErrorDescription(GetLastError());
            g_count_408++;
         }
      }
      gi_404 = 1;
   }
}

void CheckForClose() {
   bool l_ord_close_0;
   for (int l_pos_4 = 0; l_pos_4 < OrdersTotal(); l_pos_4++) {
      if (OrderSelect(l_pos_4, SELECT_BY_POS, MODE_TRADES) == FALSE) break;
      if (OrderMagicNumber() != TSSMagic || OrderSymbol() != Symbol()) continue;
      if (OrderType() == OP_BUY) {
         if (!(gi_396)) break;
         l_ord_close_0 = FALSE;
         g_count_408 = 0;
         if (DetailedLog == 1) Print("TrendStuffer v4: Found BUY position, received Close Signal trying to close trade.");
         gs_444 = "TrendStuffer v4: Found BUY position, received Close Signal trying to close trade.";
         while (!l_ord_close_0 && g_count_408 < OrderTriesNumber) {
            while (!IsTradeAllowed()) Sleep(5000);
            l_ord_close_0 = OrderClose(OrderTicket(), OrderLots(), Bid, MaxSlippage, Gold);
            if (!l_ord_close_0) {
               Print("TrendStuffer v4: Error closing BUY order try #" + g_count_408 + " " + ErrorDescription(GetLastError()));
               gs_444 = "TrendStuffer v4: Error closing BUY order try #" + g_count_408 + " " + ErrorDescription(GetLastError());
               g_count_408++;
            }
            if (l_ord_close_0) gi_432 = FALSE;
         }
         return;
      }
      if (OrderType() == OP_SELL) {
         if (!(gi_400)) break;
         l_ord_close_0 = FALSE;
         g_count_408 = 0;
         if (DetailedLog == 1) Print("TrendStuffer v4: Found SELL position, received Close Signal trying to close trade.");
         gs_444 = "TrendStuffer v4: Found SELL position, received Close Signal trying to close trade.";
         while (!l_ord_close_0 && g_count_408 < OrderTriesNumber) {
            while (!IsTradeAllowed()) Sleep(5000);
            l_ord_close_0 = OrderClose(OrderTicket(), OrderLots(), Ask, MaxSlippage, Gold);
            if (l_ord_close_0) gi_432 = FALSE;
            if (!l_ord_close_0) {
               Print("TrendStuffer v4: Error closing SELL order try #" + g_count_408 + " " + ErrorDescription(GetLastError()));
               gs_444 = "TrendStuffer v4: Error closing SELL order try #" + g_count_408 + " " + ErrorDescription(GetLastError());
               g_count_408++;
            }
         }
         return;
      }
   }
}

void TrailStop() {
   bool l_bool_0;
   double l_price_4;
   g_count_408 = 0;
   if (TrailingStart > 2) {
      for (int l_pos_12 = 0; l_pos_12 < OrdersTotal(); l_pos_12++) {
         if (OrderSelect(l_pos_12, SELECT_BY_POS) != FALSE) {
            if (OrderSymbol() != Symbol() || OrderMagicNumber() != TSSMagic) continue;
            if (OrderType() == OP_BUY) {
               if (Bid < OrderOpenPrice() + TrailingStart * Point) continue;
               gi_432 = TRUE;
               l_price_4 = Bid - TrailingStop * Point;
               if (l_price_4 > OrderStopLoss()) {
                  if (DetailedLog == 1) Print("TrendStuffer v4: TrailingStop activated, trying to modify open position.");
                  gs_444 = "TrendStuffer v4: TrailingStop activated, trying to modify open position.";
                  while (!l_bool_0 && g_count_408 < OrderTriesNumber) {
                     l_bool_0 = OrderModify(OrderTicket(), OrderOpenPrice(), l_price_4, OrderTakeProfit(), 0, Gold);
                     if (!l_bool_0) {
                        Print("TrendStuffer v4: Error modifying BUY order try #" + g_count_408 + " " + ErrorDescription(GetLastError()));
                        gs_444 = "TrendStuffer v4: Error modifying BUY order try #" + g_count_408 + " " + ErrorDescription(GetLastError());
                        g_count_408++;
                     }
                  }
               }
            }
            if (OrderType() == OP_SELL) {
               if (Ask <= OrderOpenPrice() - TrailingStart * Point) {
                  gi_432 = TRUE;
                  l_price_4 = Ask + TrailingStop * Point;
                  if (l_price_4 < OrderStopLoss()) {
                     if (DetailedLog == 1) Print("TrendStuffer v4: TrailingStop activated, trying to modify open position.");
                     gs_444 = "TrendStuffer v4: TrailingStop activated, trying to modify open position.";
                     while (!l_bool_0 && g_count_408 < OrderTriesNumber) {
                        l_bool_0 = OrderModify(OrderTicket(), OrderOpenPrice(), l_price_4, OrderTakeProfit(), 0, Gold);
                        if (!l_bool_0) {
                           Print("TrendStuffer v4: Error modifying SELL order try #" + g_count_408 + " " + ErrorDescription(GetLastError()));
                           gs_444 = "TrendStuffer v4: Error modifying SELL order try #" + g_count_408 + " " + ErrorDescription(GetLastError());
                           g_count_408++;
                        }
                     }
                  }
               }
            }
         }
      }
   }
}

void BreakEven() {
   bool l_bool_0;
   double l_price_4;
   g_count_408 = 0;
   for (int l_pos_12 = 0; l_pos_12 < OrdersTotal(); l_pos_12++) {
      if (OrderSelect(l_pos_12, SELECT_BY_POS) != FALSE) {
         if (OrderSymbol() != Symbol() || OrderMagicNumber() != TSSMagic) continue;
         if (OrderType() == OP_BUY) {
            if (Bid > OrderOpenPrice() + BreakEvenDistance * Point && OrderStopLoss() != OrderOpenPrice() + BreakEvenSLTo * Point && gi_432 == FALSE) {
               l_price_4 = OrderOpenPrice() + BreakEvenSLTo * Point;
               if (DetailedLog == 1) Print("TrendStuffer v4: BUY BreakEven activated, trying to modify open position.");
               while (!l_bool_0 && g_count_408 < OrderTriesNumber) {
                  l_bool_0 = OrderModify(OrderTicket(), OrderOpenPrice(), l_price_4, OrderTakeProfit(), 0, Gold);
                  if (!l_bool_0) {
                     Print("TrendStuffer v4: Error modifying BUY order try #" + g_count_408 + " " + ErrorDescription(GetLastError()));
                     gs_444 = "TrendStuffer v4: Error modifying BUY order try #" + g_count_408 + " " + ErrorDescription(GetLastError());
                     g_count_408++;
                  }
               }
            }
         }
         if (OrderType() == OP_SELL) {
            if (Ask < OrderOpenPrice() - BreakEvenDistance * Point && OrderStopLoss() != OrderOpenPrice() - BreakEvenSLTo * Point && gi_432 == FALSE) {
               l_price_4 = OrderOpenPrice() - BreakEvenSLTo * Point;
               if (DetailedLog == 1) Print("TrendStuffer v4: SELL BreakEven activated, trying to modify open position.");
               while (!l_bool_0 && g_count_408 < OrderTriesNumber) {
                  l_bool_0 = OrderModify(OrderTicket(), OrderOpenPrice(), l_price_4, OrderTakeProfit(), 0, Gold);
                  if (!l_bool_0) {
                     Print("TrendStuffer v4: Error modifying SELL order try #" + g_count_408 + " " + ErrorDescription(GetLastError()));
                     gs_444 = "TrendStuffer v4: Error modifying SELL order try #" + g_count_408 + " " + ErrorDescription(GetLastError());
                     g_count_408++;
                  }
               }
            }
         }
      }
   }
}

void ClearAllTrades() {
   bool l_ord_close_0;
   g_count_408 = 0;
   for (int l_pos_4 = 0; l_pos_4 < OrdersTotal(); l_pos_4++) {
      if (OrderSelect(l_pos_4, SELECT_BY_POS) != FALSE) {
         if (OrderSymbol() != Symbol() || OrderMagicNumber() != TSSMagic) continue;
         if (OrderType() == OP_BUY) {
            l_ord_close_0 = FALSE;
            g_count_408 = 0;
            if (DetailedLog == 1) Print("TrendStuffer v4: Found BUY position, ExpirationHour has came, trying to close trade.");
            while (!l_ord_close_0 && g_count_408 < OrderTriesNumber) {
               while (!IsTradeAllowed()) Sleep(5000);
               l_ord_close_0 = OrderClose(OrderTicket(), OrderLots(), Bid, MaxSlippage, Gold);
               if (!l_ord_close_0) {
                  Print("TrendStuffer v4: Error closing BUY order try #" + g_count_408 + " " + ErrorDescription(GetLastError()));
                  gs_444 = "TrendStuffer v4: Error closing BUY order try #" + g_count_408 + " " + ErrorDescription(GetLastError());
                  g_count_408++;
               }
            }
            return;
         }
         if (OrderType() == OP_SELL) {
            l_ord_close_0 = FALSE;
            g_count_408 = 0;
            if (DetailedLog == 1) Print("TrendStuffer v4: Found SELL position, ExpirationHour has come, trying to close trade.");
            gs_444 = "TrendStuffer v4: Found SELL position, ExpirationHour has come, trying to close trade.";
            while (!l_ord_close_0 && g_count_408 < OrderTriesNumber) {
               while (!IsTradeAllowed()) Sleep(5000);
               l_ord_close_0 = OrderClose(OrderTicket(), OrderLots(), Ask, MaxSlippage, Gold);
               if (!l_ord_close_0) {
                  Print("TrendStuffer v4: Error closing SELL order try #" + g_count_408 + " " + ErrorDescription(GetLastError()));
                  gs_444 = "TrendStuffer v4: Error closing SELL order try #" + g_count_408 + " " + ErrorDescription(GetLastError());
                  g_count_408++;
               }
            }
            return;
         }
      }
   }
}

void Commenting() {
   string ls_0;
   if (TerminalCompany() != "Alpari (UK) Ltd.") ls_0 = "Current broker is not Alpari UK!\nPerformance NOT guaranteed!\n";
   if (DetailedLog == 1) Comment("\nTrendStuffer System Expert Advisor v4.01\nVisit www.TrendStuffer.com for news, forum.\n\n" + ls_0 + "Last activity of this EA:\n" + gs_444);
}
